package com.malk.KLNM.util;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.smecloud.apigw.client.ApigwClient;
import com.smecloud.apigw.model.ApiRequest;
import com.smecloud.apigw.model.ApiResult;
import com.smecloud.apigw.model.ApigwConfig;
import lombok.extern.slf4j.Slf4j;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import static com.smecloud.apigw.constant.HttpMethod.GET;
@Slf4j
public class javaHelp {

    /**
     * 获取随机正整数
     *
     * @return
     */
    public static String get_randomNumber() {
        Random random = new Random();

        // 指定随机数的范围（例如，1到100之间的随机正整数）
        int min = 100000000;
        int max = 999999999;

        // 生成随机数
        int randomNumber = random.nextInt((max - min) + 1) + min;
        return String.valueOf(randomNumber);

    }

    /**
     * 获取金蝶app_signature
     */
    public static String get_app_signature(String app_key, String app_Secret) {
        try {
            // 创建一个Mac实例，并指定使用HmacSHA256算法
            Mac mac = Mac.getInstance("HmacSHA256");

            // 使用appSecret作为密钥
            SecretKeySpec secretKeySpec = new SecretKeySpec(app_Secret.getBytes(StandardCharsets.UTF_8), "HmacSHA256");
            mac.init(secretKeySpec);

            // 对appKey进行加密
            byte[] hmacBytes = mac.doFinal(app_key.getBytes(StandardCharsets.UTF_8));

            // 将加密结果转换为16进制字符串
            StringBuilder hexString = new StringBuilder(2 * hmacBytes.length);
            for (byte b : hmacBytes) {
                String hex = Integer.toHexString(0xff & b);
                if (hex.length() == 1) hexString.append('0');
                hexString.append(hex);
            }

            // 将16进制字符串进行Base64编码
            byte[] hexBytes = hexString.toString().getBytes(StandardCharsets.UTF_8);
            String base64Encoded = Base64.getEncoder().encodeToString(hexBytes);

            return base64Encoded;
        } catch (NoSuchAlgorithmException | InvalidKeyException e) {
            throw new RuntimeException("Error while generating HMAC-SHA256 hash", e);
        }
    }

    /**
     * 获取金蝶get_appToken
     */

    public static String get_appToken() throws IOException {
        String setClientID = "300657";
        String setClientSecret = "9163551ef2e2a2cd2398dc05ec527132";
        String app_key = "tcyhmh71";
        String app_Secret = "994a439a551324bc207cf8771eb645ffc8044e1d";
        ApigwConfig config = new ApigwConfig();
        //设置client_id
        config.setClientID(setClientID);
        //设置client_secret
        config.setClientSecret(setClientSecret);
        ApigwClient apigwClient = ApigwClient.getInstance();
        //初始化API网关客户端
        apigwClient.init(config);
        ApiRequest request = new ApiRequest(GET, "api.kingdee.com", "/jdyconnector/app_management/kingdee_auth_token");
        Map<String, String> map = new HashMap<>();
        map.put("app_key", app_key);
        String app_signature = get_app_signature(app_key, app_Secret);
        map.put("app_signature", app_signature);
        request.setQuerys(map);
        request.setBodyJson(JSONObject.toJSONString("").getBytes());
        ApiResult result = ApigwClient.getInstance().send(request);
        // 解析JSON字符串
        String jsonBody = result.getBody();
// 解析JSON字符串
        JSONObject jsonObject = JSON.parseObject(jsonBody);
        JSONObject dataObject = jsonObject.getJSONObject("data");
        if (jsonObject.get("description").equals("成功")){
            String appToken = dataObject.getString("app-token");
            System.out.println("获取token成功:"+appToken);
            log.info("获取token成功:"+appToken);
            return appToken;
        }else {
            System.out.println("获取token失败:"+result.getBody() );
            log.info("获取token失败:"+result.getBody());
            return "";
        }
// 获取app-token，注意fastjson对key中包含特殊字符（如-）的处理是自动的

    }
    ////


}


